// Define the motor control pins
const int motorPin1 = 7;
const int motorPin2 = 0;
const int enablePin = 6;

void setup() {
  // Set motor control pins as outputs
  pinMode(motorPin1, OUTPUT);
  pinMode(motorPin2, OUTPUT);
  pinMode(enablePin, OUTPUT);

  // Initialize serial communication for debugging
  Serial.begin(9600);

  // Initial motor setup
  digitalWrite(motorPin1, LOW);
  digitalWrite(motorPin2, LOW);
}

void loop() {
  // Set motor direction
  digitalWrite(motorPin1, HIGH);
  digitalWrite(motorPin2, LOW);

  // Set the motor speed to achieve 500 RPM
  // The actual value might need adjustment based on your motor characteristics
  int pwmValue = 250; // Half speed, adjust this to reach 500 RPM

  analogWrite(enablePin, pwmValue);

  // Print the PWM value for debugging
  Serial.print("Motor running at PWM value: ");
  Serial.println(pwmValue);
  Serial.println(motorPin1);

  delay(1000); // Run the motor for a while
}
